'RANDAT.BAS       Ray Thomas      July 1999

' Random data record selection program

OPTION BASE 1           'First element of array is 1 not 0

DIM DataFile AS STRING  'Path and name of data file
DIM TestFile AS STRING  'Test file to create
DIM InRec AS STRING     'Holds the record being worked on
DIM TotRecs AS LONG     'Number of records in data file
DIM RandNum AS LONG     'The random number generated
DIM RecLen AS INTEGER   'Record length of data file
DIM RecSel AS INTEGER   'Number of records to be selected
DIM Count AS INTEGER    'Loop counter
DIM Counter AS INTEGER  'Loop counter

DataFile$ = "E:\Ray\TestData\Ray5.dat"
RecLen = 718
TestFile$ = "E:\Ray\TestData\Ray1.tst"

CLS
PRINT
PRINT "Program to make a test file from randomly selected data records"
PRINT
PRINT
INPUT "Number of records? ", RecSel
PRINT
PRINT
PRINT "You have asked for"; RecSel; "records to be produced."
PRINT
PRINT "Record numbers selected :-"
PRINT

OPEN DataFile$ FOR RANDOM ACCESS READ LOCK READ WRITE AS #1 LEN = RecLen
FIELD #1, RecLen AS InRec$
TotRecs = LOF(1) / RecLen       'calculates the number of records in the data file
OPEN TestFile$ FOR OUTPUT ACCESS WRITE LOCK READ WRITE AS #2

DIM RecArray(TotRecs) AS LONG    'Array to hold total amount of records
DIM RandArray(RecSel) AS LONG    'Array to hold random numbers

FOR Count = 1 TO TotRecs
        RecArray(Count) = Count
NEXT Count

RANDOMIZE TIMER
FOR Count = 1 TO RecSel
        RandNum = (RND * (TotRecs - Count)) + 1 'Produce a random number
        RandArray(Count) = RandNum
        PRINT RandNum,
        FOR Counter = RandNum TO RecSel - Count
                RecArray(Counter) = RecArray(Counter + 1)
        NEXT Counter
NEXT Count

GOSUB ShellSort         'sort the chosen numbers back into order

PRINT
PRINT
PRINT "The records placed in their proper order are :-"
PRINT

FOR Count = 1 TO RecSel
        GET #1, RandArray(Count)
        PRINT RandArray(Count),
        PRINT #2, InRec$
NEXT Count
CLOSE
END

ShellSort:      'similar to bubble sort but a lot faster
  
' Set comparison offset to half the number of records in RandArray:
Offset = RecSel \ 2

DO WHILE Offset > 0          ' Loop until offset gets to zero.
        Limit = RecSel - Offset
        DO
                Switch = FALSE         ' Assume no switches at this offset.

        ' Compare elements and switch ones out of order:
                FOR Row = 1 TO Limit
                        IF RandArray(Row) > RandArray(Row + Offset) THEN
                                SWAP RandArray(Row), RandArray(Row + Offset)
                                Switch = Row
                        END IF
                NEXT Row

         ' Sort on next pass only to where last switch was made:
                Limit = Switch - Offset
        LOOP WHILE Switch

      ' No switches at last offset, try one half as big:
        Offset = Offset \ 2
LOOP
RETURN


